#lang scribble/doc
@(require "ss.rkt" (for-syntax racket/class))

@(define paper-url "http://www.cs.utah.edu/plt/publications/jfp05-ff.pdf")
@(define beamer-url "http://tug.ctan.org/macros/latex/contrib/beamer/doc/beameruserguide.pdf")

@title{Slideshow: Figure and Presentation Tools}

@author["Matthew Flatt" "Robert Bruce Findler"]

Slideshow is a library for creating presentation slides. Unlike
Powerpoint, Slideshow provides no WYSIWYG interface for constructing
slides. Instead, like @hyperlink[beamer-url]{Beamer},
a presentation is generated by a program.

To get started, run the @exec{slideshow} executable, and click the
@onscreen{Run Tutorial} link.

To learn more about Slideshow, see also ``Slideshow:
Functional Presentations'' @cite["Findler06"].

@defmodulelang*/no-declare[(slideshow)]{Most of the bindings defined
in the manual are provided by the @racketmodname[slideshow] language,
which also re-exports all of @racketmodname[racket] except for
@racket[printable<%>] (due to backward-compatibility issues)
and all of @racketmodname[pict].}

@table-of-contents[]

@; ------------------------------------------------------------------------

@include-section["guide.scrbl"]
@include-section["slides.scrbl"]
@include-section["aspect.scrbl"]
@include-section["code.scrbl"]
@include-section["play.scrbl"]
@include-section["legacy.scrbl"]

@(bibliography
  (bib-entry #:key "Findler06" 
             #:title "Slideshow: Functional Presentations"
             #:author "Robert Bruce Findler and Matthew Flatt" 
             #:location @elem{@italic{Journal of Functional Programming}, 16(4-5), pp. 583--619} 
             #:date "2006" 
             #:url paper-url))

@index-section[]
